summaryrefslogtreecommitdiffstats
path: root/target/linux/brcm47xx/base-files
diff options
context:
space:
mode:
authornbd <nbd@3c298f89-4303-0410-b956-a3cf2f4a3e73>2010-06-26 20:41:49 +0000
committernbd <nbd@3c298f89-4303-0410-b956-a3cf2f4a3e73>2010-06-26 20:41:49 +0000
commit08944ed54ad4ea46d66e2fba2f9c032c074f8eee (patch)
treeabddc378241cb70008e19540801ba47e46244f7c /target/linux/brcm47xx/base-files
parentc791c2bc42006b57f52b5cc85871e32ac2d4c390 (diff)
add back the base-files/image code from brcm-2.4 to brcm47xx
git-svn-id: svn://svn.openwrt.org/openwrt/trunk@21945 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'target/linux/brcm47xx/base-files')
-rw-r--r--target/linux/brcm47xx/base-files/etc/diag.sh28
-rwxr-xr-xtarget/linux/brcm47xx/base-files/etc/init.d/netconfig248
-rwxr-xr-xtarget/linux/brcm47xx/base-files/etc/init.d/wmacfixup33
-rw-r--r--target/linux/brcm47xx/base-files/lib/preinit/03_init_hotplug_failsafe_brcm9
-rw-r--r--target/linux/brcm47xx/base-files/lib/preinit/05_init_interfaces_brcm37
-rw-r--r--target/linux/brcm47xx/base-files/lib/preinit/05_set_failsafe_switch_brcm15
-rw-r--r--target/linux/brcm47xx/base-files/lib/preinit/15_mount_proc_brcm6
-rw-r--r--target/linux/brcm47xx/base-files/lib/preinit/15_set_preinit_interface_brcm39
-rw-r--r--target/linux/brcm47xx/base-files/lib/preinit/20_failsafe_net_echo_brcm12
-rw-r--r--target/linux/brcm47xx/base-files/lib/preinit/20_failsafe_set_boot_wait_brcm14
-rw-r--r--target/linux/brcm47xx/base-files/lib/upgrade/platform.sh16
-rwxr-xr-xtarget/linux/brcm47xx/base-files/sbin/hotplug.failsafe4
12 files changed, 461 insertions, 0 deletions
diff --git a/target/linux/brcm47xx/base-files/etc/diag.sh b/target/linux/brcm47xx/base-files/etc/diag.sh
new file mode 100644
index 000000000..3b08554c6
--- /dev/null
+++ b/target/linux/brcm47xx/base-files/etc/diag.sh
@@ -0,0 +1,28 @@
+#!/bin/sh
+# Copyright (C) 2006 OpenWrt.org
+
+set_led() {
+ local led="$1"
+ local state="$2"
+ [ -f "/proc/diag/led/$1" ] && echo "$state" > "/proc/diag/led/$1"
+}
+
+set_state() {
+ case "$1" in
+ preinit)
+ set_led dmz 1
+ set_led diag 1
+ set_led power 0
+ ;;
+ failsafe)
+ set_led diag f
+ set_led power f
+ set_led dmz f
+ ;;
+ done)
+ set_led dmz 0
+ set_led diag 0
+ set_led power 1
+ ;;
+ esac
+}
diff --git a/target/linux/brcm47xx/base-files/etc/init.d/netconfig b/target/linux/brcm47xx/base-files/etc/init.d/netconfig
new file mode 100755
index 000000000..d7839b6b4
--- /dev/null
+++ b/target/linux/brcm47xx/base-files/etc/init.d/netconfig
@@ -0,0 +1,248 @@
+#!/bin/sh /etc/rc.common
+# Copyright (C) 2006 OpenWrt.org
+
+START=05
+
+start() {
+ [ -e /etc/config/network ] && {
+ local batch
+
+ config_cb() {
+ case "$1" in
+ switch)
+ option_cb() {
+ case "$1" in
+ vlan[0-9]|vlan1[0-5])
+ local id="${1#vlan}"
+ local ports="${2%\*}"
+ append batch "delete network.eth0.${1}${N}"
+ append batch "set network.eth0_${id}=switch_vlan${N}"
+ append batch "set network.eth0_${id}.device=eth0${N}"
+ append batch "set network.eth0_${id}.vlan=${id}${N}"
+ append batch "set network.eth0_${id}.ports='${ports}'${N}"
+ ;;
+ esac
+ }
+ ;;
+ switch_vlan)
+ option_cb() { :; }
+ batch=""
+ ;;
+ esac
+ }
+
+ config_load network
+
+ [ -n "$batch" ] && {
+ logger -t netconfig "migrating switch config to new format ..."
+ echo "$batch${N}commit network" | uci batch
+ }
+
+ exit 0
+ }
+
+ mkdir -p /etc/config
+
+ (
+ if grep -E 'mtd0: 000(6|a)0000' /proc/mtd 2>&- >&-; then
+ # WGT634u
+ echo boardtype=wgt634u
+ else
+ strings "$(find_mtd_part nvram)"
+ fi
+ ) | awk '
+ function p(cfgname, name) {
+ if (c[name] != "") print " option " cfgname " \"" c[name] "\""
+ }
+
+ function vlan(id, name) {
+ if (c[name] != "") {
+ print "config switch_vlan eth0_" id
+ print " option device \"eth0\""
+ print " option vlan " id
+ print " option ports \"" c[name] "\""
+ print ""
+ }
+ }
+
+ function macinc(mac, maca, i, result) {
+ split(mac, maca, ":")
+ for (i = 1; i <= 6; i++) maca[i] = "0x" maca[i]
+ if (++maca[6] > 0xff) {
+ maca[5]++
+ maca[6] = 0
+ }
+ for (i = 1; i <= 6; i++) {
+ if (i != 1) result = result ":"
+ result = result sprintf("%02x", maca[i])
+ }
+ return result
+ }
+
+ BEGIN {
+ FS="="
+ c["lan_ifname"]="eth0.0"
+ c["wan_ifname"]="eth0.1"
+ c["vlan0ports"]="1 2 3 4 5"
+ c["vlan1ports"]="0 5"
+ getline < "/proc/diag/model"
+ model=$0
+ for (i = 0; i < 6; i++) {
+ if (mac_check != "") mac_check = mac_check ":"
+ mac_check = mac_check "[0-9a-fA-F][0-9a-fA-F]"
+ }
+ }
+
+ ($1 == "boardnum") || ($1 == "boardtype") || ($1 == "boardflags") || ($1 ~ /macaddr/) {
+ nvram[$1] = $2
+ }
+
+ END {
+ if ((model == "ASUS WL-HDD") || (model == "ASUS WL-300g") || (model == "Linksys WAP54G V1")) {
+ c["wan_ifname"] = ""
+ c["lan_ifname"] = "eth1"
+ }
+ if (model == "ASUS WL-330gE") {
+ c["wan_ifname"] = ""
+ c["lan_ifname"] = "eth0"
+ c["vlan0ports"] = ""
+ c["vlan1ports"] = ""
+ }
+ if ((model == "ASUS WL-500g") || (model == "Microsoft MN-700")) {
+ c["wan_ifname"] = "eth1"
+ c["lan_ifname"] = "eth0"
+ }
+ if ((model == "ASUS WL-500g Premium V2") || (model == "Dell TrueMobile 2300 v2") || (model == "Buffalo WHR-G125")) {
+ c["vlan0ports"] = "0 1 2 3 5"
+ c["vlan1ports"] = "4 5"
+ }
+ if (model == "Dell TrueMobile 2300") {
+ c["lan_ifname"] = "eth0"
+ c["wan_ifname"] = "eth1"
+ c["vlan0ports"] = "0 1 2 3 4 5u"
+ c["vlan1ports"] = ""
+ }
+ if (nvram["boardtype"] == "bcm94710r4") {
+ # Toshiba WRC-1000
+ c["lan_ifname"] = "eth0"
+ c["wan_ifname"] = "eth1"
+ }
+ if ((nvram["boardtype"] == "wgt634u") || (nvram["boardtype"] == "0x0467")) {
+ c["vlan0ports"] = "0 1 2 3 5"
+ c["vlan1ports"] = "4 5"
+ }
+ if ((nvram["boardtype"] == "0x042f") || (nvram["boardtype"] == "0x0472")) {
+ if (nvram["boardnum"] == "45") {
+ # WL-500gP
+ c["vlan0ports"] = "1 2 3 4 5"
+ c["vlan1ports"] = "0 5"
+ } else {
+ # Generic BCM94704
+ c["vlan0ports"] = "0 1 2 3 4 5u"
+ c["vlan1ports"] = ""
+ c["lan_ifname"] = "eth0"
+ c["wan_ifname"] = "eth1"
+
+ # MAC addresses on 4704 tend to be screwed up. Add a workaround here
+ if (nvram["et0macaddr"] ~ mac_check) {
+ c["lan_macaddr"] = nvram["et0macaddr"]
+ c["wan_macaddr"] = macinc(c["lan_macaddr"])
+ }
+ }
+ }
+ # Buffalo WBR-B11 and Buffalo WBR-G54
+ if (nvram["boardtype"] == "bcm94710ap") {
+ c["vlan0ports"] = "0 1 2 3 4 5u"
+ c["vlan1ports"] = ""
+ c["lan_ifname"] = "eth0"
+ c["wan_ifname"] = "eth1"
+ }
+ # generic broadcom 4705/4785 processor with 5397 switch?
+ # EXCEPT Linksys WRT300N V1.1
+ if ((nvram["boardtype"] == "0x478") && \
+ (model != "Linksys WRT300N V1.1")) {
+ c["vlan0ports"] = "1 2 3 4 8*"
+ c["vlan1ports"] = "0 8"
+ }
+
+ # WAP54G
+ if ((nvram["boardnum"] == "2") || \
+ (nvram["boardnum"] == "1024")) {
+ c["lan_ifname"]="eth0"
+ c["wan_ifname"]=""
+ }
+
+ # Sitecom WL-105b
+ if ((nvram["boardum"] == "2") && \
+ (nvram["GemtekPmonVer"] == "1")) {
+ c["lan_ifname"]="eth0"
+ c["wan_ifname"]=""
+ }
+
+ # ASUS WL-700gE
+ # These are actually same as defaults above. For some reason this script applies
+ # Generic BCM94704 settings instead so we revert to proper settings here.
+ # Hopefully someone will fix this properly soon.
+ if (model == "ASUS WL-700gE") {
+ c["lan_ifname"]="eth0.0"
+ c["wan_ifname"]="eth0.1"
+ c["vlan0ports"]="1 2 3 4 5"
+ c["vlan1ports"]="0 5"
+ }
+
+ if (model == "Motorola WR850G V2/V3") {
+ c["vlan0ports"]="0 1 2 3 5"
+ c["vlan1ports"]="4 5"
+ }
+ if (model == "ASUS WL-500W") {
+ c["lan_ifname"] = "eth0"
+ c["wan_ifname"] = "eth1"
+ c["vlan0ports"] = "0 1 2 3 4 5u"
+ c["vlan1ports"] = ""
+ }
+ if (model == "OvisLink WL-1600GL") {
+ c["lan_ifname"] = "eth0.0"
+ c["wan_ifname"] = "eth0.1"
+ c["vlan0ports"] = "0 1 2 3 5"
+ c["vlan1ports"] = "4 5"
+ }
+
+ if (c["vlan0ports"] || c["vlan1ports"]) {
+ print "#### VLAN configuration "
+ print "config switch eth0"
+ print " option enable 1"
+ print ""
+ vlan(0, "vlan0ports")
+ vlan(1, "vlan1ports")
+ }
+ print "#### Loopback configuration"
+ print "config interface loopback"
+ print " option ifname \"lo\""
+ print " option proto static"
+ print " option ipaddr 127.0.0.1"
+ print " option netmask 255.0.0.0"
+ print ""
+ print ""
+ print "#### LAN configuration"
+ print "config interface lan"
+ print " option type bridge"
+ p("ifname", "lan_ifname")
+ p("macaddr", "lan_macaddr")
+ print " option proto static"
+ print " option ipaddr 192.168.1.1"
+ print " option netmask 255.255.255.0"
+ print ""
+ print ""
+ if (c["wan_ifname"]) {
+ print "#### WAN configuration"
+ print "config interface wan"
+ p("ifname", "wan_ifname")
+ p("macaddr", "wan_macaddr")
+ print " option proto dhcp"
+ } else {
+ print "#### WAN configuration (disabled)"
+ print "#config interface wan"
+ print "# option proto dhcp"
+ }
+ }' > /etc/config/network
+}
diff --git a/target/linux/brcm47xx/base-files/etc/init.d/wmacfixup b/target/linux/brcm47xx/base-files/etc/init.d/wmacfixup
new file mode 100755
index 000000000..ee1b75220
--- /dev/null
+++ b/target/linux/brcm47xx/base-files/etc/init.d/wmacfixup
@@ -0,0 +1,33 @@
+#!/bin/sh /etc/rc.common
+# Copyright (C) 2010 OpenWrt.org
+
+START=41
+
+boot() {
+ [ -d /sys/class/ieee80211 ] || exit
+
+ commit=0
+
+ fixup_wmac() {
+ local cfg="$1"
+ local cfmac
+
+ config_get cfmac "$cfg" macaddr
+
+ [ "$cfmac" != "00:90:4c:5f:00:2a" ] || {
+ local nvmac="$(nvram get il0macaddr 2>/dev/null)"
+ [ -n "$nvmac" ] && [ "$nvmac != "$cfmac ] && {
+ uci set wireless.$cfg.macaddr="$nvmac"
+ commit=1
+ }
+ }
+ }
+
+ config_load wireless
+ config_foreach fixup_wmac wifi-device
+
+ [ "$commit" = 1 ] && uci commit wireless
+}
+
+start() { :; }
+stop() { :; }
diff --git a/target/linux/brcm47xx/base-files/lib/preinit/03_init_hotplug_failsafe_brcm b/target/linux/brcm47xx/base-files/lib/preinit/03_init_hotplug_failsafe_brcm
new file mode 100644
index 000000000..b0f4a4efa
--- /dev/null
+++ b/target/linux/brcm47xx/base-files/lib/preinit/03_init_hotplug_failsafe_brcm
@@ -0,0 +1,9 @@
+#!/bin/sh
+
+init_hotplug_failsafe() {
+ echo '/sbin/hotplug.failsafe' > /proc/sys/kernel/hotplug
+}
+
+boot_hook_add preinit_main init_hotplug_failsafe
+
+
diff --git a/target/linux/brcm47xx/base-files/lib/preinit/05_init_interfaces_brcm b/target/linux/brcm47xx/base-files/lib/preinit/05_init_interfaces_brcm
new file mode 100644
index 000000000..3cd760e2d
--- /dev/null
+++ b/target/linux/brcm47xx/base-files/lib/preinit/05_init_interfaces_brcm
@@ -0,0 +1,37 @@
+#!/bin/sh
+
+set_preinit_iface() {
+ ifname=eth0
+
+ insmod diag
+
+ # hardware specific overrides
+ case "$(cat /proc/diag/model)" in
+ "Linksys WAP54G V1") ifname=eth1;;
+ "ASUS WL-HDD") ifname=eth1;;
+ "ASUS WL-300g") ifname=eth1;;
+ "ASUS (unknown, BCM4702)") ifname=eth1;;
+ "Sitecom WL-105b") ifname=eth1;;
+ esac
+ ifconfig $ifname 0.0.0.0 up
+}
+
+check_module () {
+ module="$1"; shift; params="$*"
+
+ insmod "$module" "$params"
+ sleep 1
+ grep "^$module" /proc/modules
+ return $?
+}
+
+init_iface() {
+ check_module tg3
+ insmod switch-core
+ check_module switch-robo || check_module switch-adm || {
+ check_module bcm57xx activate_gpio=0x4 && cpu_port="8u*"
+ } || rmmod switch-core
+}
+
+boot_hook_add preinit_main set_preinit_iface
+boot_hook_add preinit_main init_iface
diff --git a/target/linux/brcm47xx/base-files/lib/preinit/05_set_failsafe_switch_brcm b/target/linux/brcm47xx/base-files/lib/preinit/05_set_failsafe_switch_brcm
new file mode 100644
index 000000000..a93559f97
--- /dev/null
+++ b/target/linux/brcm47xx/base-files/lib/preinit/05_set_failsafe_switch_brcm
@@ -0,0 +1,15 @@
+#!/bin/sh
+
+failsafe_ip() {
+ [ -d /proc/switch/eth0 ] && [ "$ifname" = "eth0" ] && {
+ ifconfig eth0 0.0.0.0 down
+ echo "0 1 2 3 4 ${cpu_port:-5u*}" > /proc/switch/eth0/vlan/0/ports
+ }
+
+ [ -n "$pi_ifname" ] && grep -q "$pi_ifname" /proc/net/dev && {
+ ifconfig $pi_ifname $pi_ip netmask $pi_netmask broadcast $pi_broadcast up
+ }
+}
+
+boot_hook_add failsafe failsafe_ip
+
diff --git a/target/linux/brcm47xx/base-files/lib/preinit/15_mount_proc_brcm b/target/linux/brcm47xx/base-files/lib/preinit/15_mount_proc_brcm
new file mode 100644
index 000000000..fd5add16a
--- /dev/null
+++ b/target/linux/brcm47xx/base-files/lib/preinit/15_mount_proc_brcm
@@ -0,0 +1,6 @@
+#!/bin/sh
+
+do_mount_procfs() {
+ mount none /proc -t proc
+}
+
diff --git a/target/linux/brcm47xx/base-files/lib/preinit/15_set_preinit_interface_brcm b/target/linux/brcm47xx/base-files/lib/preinit/15_set_preinit_interface_brcm
new file mode 100644
index 000000000..fdc7c71ca
--- /dev/null
+++ b/target/linux/brcm47xx/base-files/lib/preinit/15_set_preinit_interface_brcm
@@ -0,0 +1,39 @@
+#!/bin/sh
+
+port_net_echo() {
+ [ -n "$pi_ifname" ] && grep -q "$pi_ifname" /proc/net/dev && {
+ if [ "$pi_preinit_net_messages" = "y" ] || [ "$pi_failsafe_net_message" = "true" ] && [ "$pi_preinit_no_failsafe_netmsg" != "y" ]; then
+ netmsg $pi_broadcast "$1"
+ fi
+ }
+}
+
+preinit_ip_deconfig() {
+ if [ -z "$pi_ifname" ]; then
+ ifconfig $ifname 0.0.0.0 down
+ else
+ grep -q "$pi_ifname" /proc/net/dev && {
+ ifconfig $pi_ifname 0.0.0.0 down
+ }
+ fi
+}
+
+preinit_net_echo() {
+ preinit_ip
+
+ [ -d /proc/switch/eth0 ] && [ "$pi_ifname" = "eth0" ] && {
+ echo 1 > /proc/switch/eth0/reset
+
+ # this would be easier if we blasted the message across all ports
+ # but we don't want packets leaking across interfaces
+ for port in $(seq 0 4); do {
+ echo "$port ${cpu_port:-5u*}" > /proc/switch/eth0/vlan/0/ports
+ port_net_echo $1
+ }; done
+
+ echo "0 ${cpu_port:-5u*}" > /proc/switch/eth0/vlan/0/ports
+
+ } || port_net_echo $1
+}
+
+
diff --git a/target/linux/brcm47xx/base-files/lib/preinit/20_failsafe_net_echo_brcm b/target/linux/brcm47xx/base-files/lib/preinit/20_failsafe_net_echo_brcm
new file mode 100644
index 000000000..f030cb283
--- /dev/null
+++ b/target/linux/brcm47xx/base-files/lib/preinit/20_failsafe_net_echo_brcm
@@ -0,0 +1,12 @@
+#!/bin/sh
+
+indicate_failsafe() {
+ preinit_net_echo() {
+ port_net_echo $1
+ }
+ echo "- failsafe -"
+ preinit_net_echo "Entering Failsafe!\n"
+ indicate_failsafe_led
+}
+
+
diff --git a/target/linux/brcm47xx/base-files/lib/preinit/20_failsafe_set_boot_wait_brcm b/target/linux/brcm47xx/base-files/lib/preinit/20_failsafe_set_boot_wait_brcm
new file mode 100644
index 000000000..da721b848
--- /dev/null
+++ b/target/linux/brcm47xx/base-files/lib/preinit/20_failsafe_set_boot_wait_brcm
@@ -0,0 +1,14 @@
+#!/bin/sh
+
+. /etc/functions.sh
+
+set_boot_wait() {
+ [ -x "/usr/sbin/nvram" ] && {
+ [ "$(nvram get boot_wait)" != "on" ] && {
+ nvram set boot_wait=on
+ nvram commit
+ }
+ }
+}
+
+boot_hook_add failsafe set_boot_wait
diff --git a/target/linux/brcm47xx/base-files/lib/upgrade/platform.sh b/target/linux/brcm47xx/base-files/lib/upgrade/platform.sh
new file mode 100644
index 000000000..9921cf571
--- /dev/null
+++ b/target/linux/brcm47xx/base-files/lib/upgrade/platform.sh
@@ -0,0 +1,16 @@
+PART_NAME=linux
+
+platform_check_image() {
+ [ "$ARGC" -gt 1 ] && return 1
+
+ case "$(get_magic_word "$1")" in
+ # .trx files
+ 4844) return 0;;
+ *)
+ echo "Invalid image type. Please use only .trx files"
+ return 1
+ ;;
+ esac
+}
+
+# use default for platform_do_upgrade()
diff --git a/target/linux/brcm47xx/base-files/sbin/hotplug.failsafe b/target/linux/brcm47xx/base-files/sbin/hotplug.failsafe
new file mode 100755
index 000000000..0544339de
--- /dev/null
+++ b/target/linux/brcm47xx/base-files/sbin/hotplug.failsafe
@@ -0,0 +1,4 @@
+#!/bin/sh
+case "$1" in
+ button) kill -USR1 1;;
+esac